﻿using System;
using System.Data;

using DevExpress.Data;
using DevExpress.Data.Filtering;
using DevExpress.XtraEditors;

namespace TestProject
{
    /// <summary>
    /// 메인 폼
    /// </summary>
    public partial class MainForm : XtraForm
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainForm()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainForm()
        {
            InitializeComponent();

            DataSet dataSet = new DataSet();

            dataSet.ReadXml("nwind.xml");

            this.gridControl.DataSource = dataSet;
            this.gridControl.DataMember = "Orders";

            this.gridView.ActiveFilterCriteria = CriteriaOperator.Parse("Freight > 0");

            this.barEditItem.EditValueChanged += barEditItem_EditValueChanged;
            this.gridView.SubstituteFilter    += gridView_SubstituteFilter;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region 바 편집 항목 편집 값 변경시 처리하기 - barEditItem_EditValueChanged(sender, e)

        /// <summary>
        /// 바 편집 항목 편집 값 변경시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void barEditItem_EditValueChanged(object sender, EventArgs e)
        {
            CriteriaOperator criteriaOperator = this.gridView.ActiveFilterCriteria;

            this.gridView.BeginDataUpdate();

            try
            {
                this.gridView.ActiveFilterCriteria = null;
                this.gridView.ActiveFilterCriteria = criteriaOperator;
            }
            finally
            {
                this.gridView.EndDataUpdate();
            }
        }

        #endregion
        #region 그리드 뷰 필터 대체하기 - gridView_SubstituteFilter(sender, e)

        /// <summary>
        /// 그리드 뷰 필터 대체하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void gridView_SubstituteFilter(object sender, SubstituteFilterEventArgs e)
        {
            e.Filter &= CriteriaOperator.Parse("getyear(OrderDate) = ?", Convert.ToInt32(this.barEditItem.EditValue));
        }

        #endregion
    }
}